#include<iostream>
#include"CheapClock.h"

int main(int argc,char **argv)
{
  CheapClock cheapclock;
  ACE_Time_Value currentgtofday;
  {
    ACE_hrtime_t vor100gtof = ACE_OS::gethrtime();
    for(int i=0;i<100;i++)
      {
	currentgtofday = ACE_OS::gettimeofday();
      }
    ACE_hrtime_t nach100gtof = ACE_OS::gethrtime();
    ACE_hrtime_t ticks100gtof = nach100gtof-vor100gtof;
    double mgtof = ticks100gtof/100.0;
    std::cout << "100*gettimeofday " << ticks100gtof << " ticks"
	      << " 1*getimeofday " << mgtof << " ticks" << std::endl;
  }
  std::clog << "Calibrating ... " << std::endl;
  struct timespec checkinterval = { 1,0};
  ACE_OS::nanosleep(&checkinterval);
  currentgtofday = ACE_OS::gettimeofday();
  cheapclock.timesample(currentgtofday);
  {
    ACE_hrtime_t vor100ck = ACE_OS::gethrtime();
    for(int i=0;i<100;i++)
    {
	ACE_Time_Value currentcheap = cheapclock.gettime();
    }
    ACE_hrtime_t nach100ck = ACE_OS::gethrtime();
    ACE_hrtime_t ticks100ck = nach100ck-vor100ck;
    double mck = ticks100ck/100.0;
    std::cout << "100*cheap.gettime " << ticks100ck << " ticks"
	      << " 1*cheap.gettime " << mck << " ticks" << std::endl;
  }
  {
    time_t t = currentgtofday.sec();
    ACE_hrtime_t vor100ts = ACE_OS::gethrtime();
    for(int i=0;i<100;i++)
    {
      currentgtofday.sec(++t);
      cheapclock.timesample(currentgtofday);
    }
    ACE_hrtime_t nach100ts = ACE_OS::gethrtime();
    ACE_hrtime_t ticks100ts = nach100ts-vor100ts;
    double mts = ticks100ts/100.0;
    std::cout << "100*cheap.timesample " << ticks100ts << " ticks"
	      << " 1*cheap.timesample " << mts << " ticks" << std::endl;
  }
}
